﻿#region Sub-Lesson 4.2 Code Snippets

#Will show all methods and properties and object that is piped to it
Get-Service | Get-Member

#endregion

#region Sub-Lesson 4.3 Code Snippets

#Counts how many files are in specified path
Get-ChildItem -Path C:\PoSh -File | Measure-Object

#Sums the specified property off of the files that are in the specified path
Get-ChildItem -Path C:\PoSh -File | Measure-Object -Property Length -Sum

#Sums, Averages, selects minimum and maximum values within specified file content
Get-Content C:\PoSh\TestScores.txt | Measure-Object -Sum -Average -Minimum -Maximum

#endregion

#region Sub-Lesson 4.4 Code Snippets

#Saves all of the current running processes to specified text file
Get-Process | Out-File -FilePath C:\PoSh\Processes.txt

#Shows the content of specified text document
Get-Content C:\PoSh\Processes.txt

#Outputs a snapshot of the processes running to a GUI application
Get-Process | Out-GridView

#Outputs the Processes to a string value
Get-Process | Out-String

#Prints the output of the service cmdlet
Get-Service | Out-Printer

#endregion

#region Sub-Lesson 4.5 Code Snippets

#Output the EventLog information in CSV format to specified File
Get-EventLog –LogName Security –Newest 10 | ConvertTo-Csv | Out-File C:\PoSh\securityLog.csv

#Read the content of specified file that is in CSV format
Get-Content C:\PoSh\securityLog.csv | ConvertFrom-Csv

#Output Process information to HTML file
Get-Process | ConvertTo-HTML | Out-File C:\PoSh\processes.html

#Output Process information to HTML File that has a header of the current Date
Get-Process | ConvertTo-HTML –PreContent (Get-Date) | Out-File C:\PoSh\processes.html –Force

#endregion

#region Sub-Lesson 4.6 Code Snippets

#Export Process information to an XML File
Get-Process | Export-CliXML C:\PoSh\Processes.xml

#Import the Process information from specified XML File, second command shows content
$services = Import-CliXML C:\PoSh\Processes.xml
$services

#Notice all properties and methods exist as they would if the command was run on it's own
$services | Get-Member

#Export Process information to specified csv file
Get-Process | Export-Csv C:\PoSh\Processes.csv

#Import the Process ifnromation from specified CSV File, second command shows content
$processes = Import-Csv C:\PoSh\Processes.csv
$processes

#Notice that the properties are different and the methods are different
$processes | Get-Member

#endregion

#region Sub-Lesson 4.7 Code Snippets

#Returns True because they are the same value even though the case is different
“PoSh” –eq “Posh”

#Returns false because they are not case sensative
“PoSh” –ne “PoSh”

#Returns true
8 –gt 2

#Returns true because ge is greater than or equal to
2 –ge 2

#Returns falase because no wildcard is used
“PowerShell” –like “P”

#Returns true because wildcard is used
“PowerShell” –like “P*”

#Returns true because both statements are true
2 –eq 2 –and 3 –ne 4

#Returns true because at least one statement is true
“PoSh” –like “P*” –or 2 –eq 48

#Returns false because both statements are true
2 –eq 2 –xor 4 –eq 4

#Returns true because only one statement is true
2 –eq 2 –xor 4 –ne 4

#Returns false because -not is in front of the first 2
–not 2 –eq 2

#endregion

#region Sub-Lesson 4.8 Code Snippets

#Only returns objects where the comparison in the where-object statement is true
Get-Service | Where-Object Status –eq Stopped

#Short hand way of writing same command above
Get-Service | ? Status –eq Stopped

#Advanced where statement
Get-Service | Where-Object { $_.Status -eq "Stopped" -and $_.DisplayName -like "Windows*"}

#endregion

#region Sub-Lesson 4.9 Code Snippets

#Returns specified property from object
Get-Service | Where-Object Status –eq Stopped | ForEach-Object Name

#Executes code in the code block on each object individually
Get-Service | Where-Object Status –eq Stopped | ForEach-Object { $_.Name + “ is currently “ + $_.Status }

#endregion