﻿#region Sub-Lesson 5.1 Code Snippets

#Selects specified properties from objects piped to cmdlet
Get-Service | Select-Object –Property Name, Status

#Short hand to write cmdlet
Get-Process | Select ProcessName

#Short hand, selects only unique processes
Get-Process | Select ProcessName –Unique

#Expends an array that is returned from the object set, only shows unique objects
Get-Process | Select ProcessName –ExpandProperty Modules –Unique

#Perform calculation and creates a custom column that doesn't exists on the object
Get-Process | Select ProcessName, @{n=‘VirtualMemoryMB’;e={$_.VM/1MB}}

#Imports data from a CSV, and creates a calculation based on file
$studentScores = Import-Csv C:\PoSh\StudentScores.csv
$studentScores | Select *, @{n="FinalScore";e={([int]$_.Test1+$_.Test2+$_.Test3)/3}} 

#endregion

#region Sub-Lesson 5.2 Code Snippets

#Changes sort order objects
Get-ChildItem | Sort-Object –Descending

#Sorts by specified property
Get-ChildItem 'C:\Windows' -File | Sort-Object -Property Length  

#Sorts by specified property then performs a calculated column using a Select-Object
Get-ChildItem 'C:\Windows' -File | Sort-Object -Property Length -Descending | Select-Object Name, @{n='SizeKB';e={$_.Length/1KB}}, LastWriteTime 

#Advanced Sorting using expressions
Get-Service | Sort-Object -Property @{E="Status";Descending=$true},@{E="DisplayName";Descending=$false} 

#endregion

#region Sub-Lesson 5.3 Code Snippets

#Selects a single property and show it in multiple columns
Get-Process | Format-Wide –Property ProcessName 

#Selects a single property and show it in specified amount of colums
Get-Process | Format-Wide –Property ProcessName –Column 5

#Selects a single property and groups like named properties together - Not efficient as there will be duplicate groups
Get-Service | Format-Wide -Property Name -GroupBy Status  

#Like the above command, but this time they will be properly grouped as they are in the correct order
Get-Service | Sort-Object -Property Status | Format-Wide -Property Name -GroupBy Status  

#Forces a list format on the output
Get-Process | Format-List

#Only shows specified properties in list format
Get-Process | Sort-Object –Unique | Format-List –Property ProcessName, CPU

#Shows specified properties and tries to group them - Not efficient as there will be duplicate groups
Get-Service | Format-Table -Property Name, Status -GroupBy Status 

#Like the above command, but sorts the objects first so they are all properly grouped
Get-Service | Sort-Object Status | Format-Table -Property Name, Status -GroupBy Status

#This command by default shows in list format
Get-PSSnapin

#Forces to be formated a table
Get-PSSnapin | Format-Table

#Only shows specified properties in table format
Get-Process | Format-Table –Property ProcessName, CPU

#Groups the objects by specified property
Get-Service | Sort-Object Status | Format-Table -Property Name, Status -GroupBy Status 

#endregion